"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const graphql_tag_1 = __importDefault(require("graphql-tag"));
const hasPermission_1 = __importDefault(require("./directives/hasPermission"));
const hasRole_1 = __importDefault(require("./directives/hasRole"));
const isAuthenticated_1 = __importDefault(require("./directives/isAuthenticated"));
const createAuthDirectives = (options) => {
    var _a, _b, _c;
    return ({
        hasPermission: hasPermission_1.default((_a = options) === null || _a === void 0 ? void 0 : _a.hasPermissionHandler),
        hasRole: hasRole_1.default((_b = options) === null || _b === void 0 ? void 0 : _b.hasRoleHandler),
        isAuthenticated: isAuthenticated_1.default((_c = options) === null || _c === void 0 ? void 0 : _c.isAuthenticatedHandler),
    });
};
exports.createAuthDirectives = createAuthDirectives;
const authTypeDefs = graphql_tag_1.default `
  directive @isAuthenticated on FIELD | FIELD_DEFINITION | INPUT_FIELD_DEFINITION
  directive @hasPermission(permissions: [String!]!) on FIELD | FIELD_DEFINITION | INPUT_FIELD_DEFINITION
  directive @hasRole(roles: [String!]!) on FIELD | FIELD_DEFINITION | INPUT_FIELD_DEFINITION
`;
exports.authTypeDefs = authTypeDefs;
